require "ruboty/packman/actions/packman"

module Ruboty
  module Handlers
    class Packman < Base
      on(
        /register repo (?<organization>.+)\/(?<repository>.+)\z/,
        name: 'register',
        description: '[packman] register repository'
      )

      on(
        /update repo (?<organization>.+)\/(?<repository>.+)\z/,
        name: 'update',
        description: '[packman] library update'
      )

      on(
        /remove repo (?<organization>.+)\/(?<repository>.+)\z/,
        name: 'remove',
        description: '[packman] remove repository'
      )

      def register(message)
        action_handler(message).register
      end

      def update(message)
        action_handler(message).update
      end

      def remove(message)
        action_handler(message).remove
      end

      private

      def action_handler(message)
        Ruboty::Packman::Actions::Packman.new(message)
      end
    end
  end
end
