module Ruboty
  module Packman
    module Actions
      class Packman < Ruboty::Actions::Base
        NAMESPACE = 'packman'

        def register
          if repositories.include?(repo.full_name)
            message.reply("already registered. #{repo.full_name}")
            return
          end

          message.reply("registering...")
          repo.sync!

          repositories << repo.full_name
          message.reply("registered:tada:  #{repo.full_name}")
        end

        def update
          unless repositories.include?(repo.full_name)
            message.reply("not registered. please register #{repo.full_name}")
            return
          end

          message.reply("please wait...")
          repo.sync!
          repo.bundle_update!
          repo.push!
          url = repo.pull_request!

          message.reply("pull requested:tada: #{url}")
        end

        def remove
          unless repositories.include?(repo.full_name)
            message.reply("not registered. #{repo.full_name}")
            return
          end

          repo.clean!
          repositories.delete(repo.full_name)

          message.reply("removed. #{repo.full_name}")
        end

        private

        def repositories
          message.robot.brain.data[NAMESPACE] ||= []
        end

        def repo
          @repo ||= Ruboty::Packman::GithubRepository.new(message[:organization], message[:repository])
        end
      end
    end
  end
end

